#include <QtGui>
#include <QtCore>
// #include <QGLWidget>
#include <QtOpenGL>
#include "Figure3D.h"

Figure3D::Figure3D(QWidget* pwgt/*= 0*/) : QGLWidget(pwgt), 
                                            m_xRotate(0), 
                                            m_yRotate(0),
                                            m_zRotate(0),
                                            m_Scale(1)
{ 
//  Figure3D      pwgt 
} 

/*virtual*/void Figure3D::initializeGL() 
{

   qglClearColor(Qt::white);         //     
   glEnable(GL_DEPTH_TEST);          //       ?? 
  // glShadeModel(GL_FLAT);            //    
   m_nFigure3D = createFigure3D(1.0f); //   

}

/*virtual*/void Figure3D::resizeGL(int nWidth, int nHeight) 
{ 
   // glViewport(0, 0, (GLint)nWidth, (GLint)nHeight); //        
   
   glViewport((GLint)nWidth/2-(GLint)nHeight/2, 0, (GLint)nHeight, (GLint)nHeight); //  !!!      !!!
   
   glMatrixMode(GL_PROJECTION);                     //     ( ) ?? 
   glLoadIdentity();                                //      ?? 
                                                    //  
   
   // glFrustum(-0.0, 0.0, -0.0, 0.0, 0.0, 0.0);      //   
   
   //  : (, , , , , )
   
   glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);
}

/*virtual*/void Figure3D::paintGL() 
{ 
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //   

   glMatrixMode(GL_MODELVIEW);                         //      
   glLoadIdentity();                                   //    
   // glTranslatef(-0.5, -0.5, -0.5);                     //  (   )
   
   glRotatef(m_xRotate, 1.0, 0.0, 0.0); //     (  ,  )
   glRotatef(m_yRotate, 0.0, 1.0, 0.0); 
   glRotatef(m_zRotate, 0.0, 0.0, 1.0);
   
   glScalef(m_Scale*1.0f, m_Scale*1.0f, m_Scale*1.0f);
   
   glCallList(m_nFigure3D);  //    glCallList       . 

} 

/*virtual*/void Figure3D::mousePressEvent(QMouseEvent* pe) 
{ 
   m_ptPosition = pe->pos(); //       m_ptPosition  
                             //     
} 

/*virtual*/void Figure3D::mouseMoveEvent(QMouseEvent* pe) 
{
   m_xRotate += 180 * (GLfloat) (pe->y() - m_ptPosition.y()) / height(); //   
   m_yRotate += 180 * (GLfloat) (pe->x() - m_ptPosition.x()) / width(); 
      
   updateGL(); //  
   
   m_ptPosition = pe->pos(); 
}

/*virtual*/void Figure3D::keyPressEvent(QKeyEvent* pe)
{
   switch (pe -> key())
   {
         case Qt::Key_Up:    m_Scale = m_Scale*1.02;
         break;
         
         case Qt::Key_Down:  m_Scale = m_Scale/1.02;
         break;
         
         case Qt::Key_Left:  m_zRotate += 2;
         break;
         
         case Qt::Key_Right: m_zRotate -= 2;
         break;
         
         case Qt::Key_Space:  //    
            m_Scale = 1;
            m_xRotate = 0;
            m_yRotate = 0;
            m_zRotate = 0;
         break;
   }

   updateGL(); //  
}

GLuint Figure3D::createFigure3D(GLfloat fSize/*=1.0f*/) 
{ 
   GLuint n = glGenLists(1); //       
                             //    ??
      
   glNewList(n, GL_COMPILE); 
//       glBegin(GL_TRIANGLE_FAN); // 
//          qglColor(Qt::green); 
//          glVertex3f(0.0, fSize, 0.0); 
//          glVertex3f(-fSize, -fSize, fSize); 
//          glVertex3f(fSize, -fSize, fSize);
//           
//          qglColor(Qt::yellow); 
//          glVertex3f(fSize, -fSize, -fSize); 
//          
//          qglColor(Qt::blue); 
//          glVertex3f(-fSize, -fSize, -fSize); 
//          
//          qglColor(Qt::white); 
//          glVertex3f(-fSize, -fSize, fSize); 
//       glEnd(); 
//        
//       glBegin(GL_QUADS) ; 
//          qglColor(Qt::red); // "#339933" 
//          glVertex3f(-fSize, -fSize, fSize);
//          glVertex3f(fSize, -fSize, fSize);
//          glVertex3f(fSize, -fSize, -fSize);
//          glVertex3f(-fSize, -fSize, -fSize);
//       glEnd(); 
         
         glBegin(GL_QUADS);
            glColor4f(0.0f, 0.0f, 1.0f, 1.0f);
            glVertex3f(0.4*fSize, 0.4*fSize, -0.4*fSize);
            glVertex3f(-0.4*fSize, 0.4*fSize, -0.4*fSize);
            glVertex3f(-0.4*fSize, 0.4*fSize, 0.4*fSize);
            glVertex3f(0.4*fSize, 0.4*fSize, 0.4*fSize);         
         glEnd();
         
         glBegin(GL_QUADS);
            glColor4f(0.0f, 0.4f, 0.75f, 1.0f);
            glVertex3f(-0.4*fSize, 0.4*fSize, 0.4*fSize);
            glVertex3f(0.4*fSize, 0.4*fSize, 0.4*fSize); 
            glVertex3f(0.4*fSize, -0.4*fSize, 0.4*fSize);
            glVertex3f(-0.4*fSize, -0.4*fSize, 0.4*fSize);
         glEnd();   
         
         glBegin(GL_QUADS);
            glColor4f(0.75f, 0.25f, 0.0f, 1.0f);
            glVertex3f(0.4*fSize, -0.4*fSize, 0.4*fSize);
            glVertex3f(-0.4*fSize, -0.4*fSize, 0.4*fSize); 
            glVertex3f(-0.4*fSize, -0.4*fSize, -0.4*fSize); 
            glVertex3f(0.4*fSize, -0.4*fSize, -0.4*fSize);
         glEnd();     
         
         glBegin(GL_QUADS);
            glColor4f(0.75f, 0.4f, 0.25f, 1.0f);
            glVertex3f(-0.4*fSize, -0.4*fSize, -0.4*fSize); 
            glVertex3f(0.4*fSize, -0.4*fSize, -0.4*fSize);
            glVertex3f(0.4*fSize, 0.4*fSize, -0.4*fSize);
            glVertex3f(-0.4*fSize, 0.4*fSize, -0.4*fSize);      
         glEnd(); 
         
         glBegin(GL_QUADS);
            glColor4f(0.0f, 0.75f, 0.25f, 1.0f);
            glVertex3f(0.4*fSize, 0.4*fSize, 0.4*fSize); 
            glVertex3f(0.4*fSize, 0.4*fSize, -0.4*fSize);
            glVertex3f(0.4*fSize, -0.4*fSize, -0.4*fSize);
            glVertex3f(0.4*fSize, -0.4*fSize, 0.4*fSize);      
         glEnd(); 
         
         glBegin(GL_QUADS);
            glColor4f(0.25f, 0.75f, 0.0f, 1.0f);
            glVertex3f(-0.4*fSize, 0.4*fSize, 0.4*fSize); 
            glVertex3f(-0.4*fSize, 0.4*fSize, -0.4*fSize);
            glVertex3f(-0.4*fSize, -0.4*fSize, -0.4*fSize);
            glVertex3f(-0.4*fSize, -0.4*fSize, 0.4*fSize);      
         glEnd(); 
         

         
   glEndList(); 

return n; 
} 